## 环境
     CentOS Linux release 7.7.1908 (Core)
    单台服务器至少4G内存
    
## 步骤一: 调整max_map_count大小，不然会导致es无法启动。
    需要在每台机器都执行 echo 'vm.max_map_count=262144' >> /etc/sysctl.conf && sysctl -p

## 步骤二: 创建es存储数据目录，并授权。
    先cat /etc/group 查看是否有uid=1000的用户,没有则创建 
    mkdir /es-data && chown -R 1000:1000 /es-data
    
## 步骤三： 创建应用
    apiVersion: v1
    kind: Service
    metadata:
      name: es-1
      labels:
        app: es-1
    spec:
      type: NodePort
      ports:
        - port: 9300
          protocol: TCP
          name: port-9300
        - port: 9200
          protocol: TCP
          name: port-9200
          nodePort: 32630
      selector:
        app: es-1
    ---
    apiVersion: apps/v1
    kind: Deployment
    metadata:
      name: es-1
    spec:
      strategy:
        type: Recreate
      selector:
        matchLabels:
          app: es-1
      template:
        metadata:
          labels:
            app: es-1
        spec:
          nodeName: master1
          containers:
            - name: es-1
              image: elasticsearch:7.5.0
              imagePullPolicy: Always
              livenessProbe:
                httpGet:
                  port: 9200
                periodSeconds: 10
              ports:
                - containerPort: 9200
                  protocol: TCP
                - containerPort: 9300
                  protocol: TCP
              env:
                - name: ES_JAVA_OPTS
                  value: "-Xmx1g -Xms1g"
                - name: node.master
                  value: "true"
                - name: node.data
                  value: "true"
                - name: node.name
                  value: "es-1"
                - name: cluster.name
                  value: "efk-cluster"
                - name: discovery.seed_hosts
                  value: "es-1"
            - name: cluster.initial_master_nodes
              value: "es-1"
          volumeMounts:
            - mountPath: /usr/share/elasticsearch/data
              name: es-data
      volumes:
        - name: es-data
          hostPath:
            path: /es-data
