## ES集群
    参见 https://qingmu.io/2019/08/01/Deploy-Elasticsearch-Cluster-on-kubernetes/
    
## 安装

##### 步骤一: 调整max_map_count大小，不然会导致es无法启动，需要在每台机器都执行
    echo 'vm.max_map_count=262144' >> /etc/sysctl.conf && sysctl -p
    
##### 步骤二: 创建es存储数据目录，并授权。
    先cat /etc/group 查看是否有uid=1000的用户,没有则创建 
    mkdir /es-data && chown -R 1000:1000 /es-data
     
##### 步骤三: es.yaml
    apiVersion: v1
    kind: ConfigMap
    metadata:
      name: es
    data:
      elasticsearch.yml: |
        cluster.name: "${NAMESPACE}"
        node.name: "${POD_NAME}"
        network.host: 0.0.0.0
        discovery.seed_hosts: "es-in"
        cluster.initial_master_nodes: "es-0,es-1,es-2"
        node.master: "true"
        node.data: "true"
    ---
    apiVersion: v1
    kind: Service
    metadata:
      name: es-in
      labels:
        app: es
    spec:
      clusterIP: None
      ports:
        - port: 9300
          protocol: TCP
          name: in
      selector:
        app: es
    ---
    apiVersion: v1
    kind: Service
    metadata:
      name: es-out
      labels:
        app: es
    spec:
      ports:
        - port: 9200
          protocol: TCP
          name: out
      selector:
        app: es
    ---
    apiVersion: apps/v1
    kind: StatefulSet
    metadata:
      name: es
    spec:
      serviceName: es
      selector:
        matchLabels:
          app: es
      replicas: 3
      template:
        metadata:
          labels:
            app: es
        spec:
          terminationGracePeriodSeconds: 10
          containers:
            - name: es
              image: elasticsearch:7.5.0
              imagePullPolicy: Always
              ports:
                - containerPort: 9200
                  protocol: TCP
                - containerPort: 9300
                  protocol: TCP
              env:
                - name: NAMESPACE
                  valueFrom:
                    fieldRef:
                      fieldPath: metadata.namespace
                - name: POD_NAME
                  valueFrom:
                    fieldRef:
                      fieldPath: metadata.name
                - name: ES_JAVA_OPTS
                  value: "-Xmx1g -Xms1g"
              volumeMounts:
                - name: es-config
                  mountPath: /usr/share/elasticsearch/config/elasticsearch.yml
                  subPath: elasticsearch.yml
          volumes:
            - name: es-config
              configMap:
                name: es
