#### 环境

|  | 说明 |
| --- | --- |
| 操作系统 | CentOS Linux release 7.7.1908 (Core) 2CPU 4G|
| Docker | 18.09.7| 
| Kubernetes | v1.16.2 | 
| Etcd | v3.3.15 | 

#### 上传离线包至服务器
|  | 说明 |
| --- | --- |
| docker-18.09.7.tar.gz | docker 相关rpm包|
| nfs.tar.gz | 挂载 nfs 网络存储的nfs-utils相关包 | 
| k8s-v1.16.2-pkgs-rpm.tar.gz | k8s相关rpm包| 
| k8s-v1.16.2-images.tar |k8s相关docker镜像 | 
|calico-3.9.2.yaml| 网络插件|

#### 脚本说明
|  | 说明 |
| --- | --- |
| install-kubelet.sh | Master、Node都执行|
|init-master.sh | Master节点执行|

#### Master节点

##### 步骤一、 解压离线包
    cd ~
    tar zxvf docker-18.09.7.tar.gz
    tar zxvf utils.tar.gz
    tar zxvf nfs.tar.gz
    tar zxvf k8s-v1.16.2-pkgs-rpm.tar.gz

##### 步骤二、 设置环境变量
    cat>env<<EOF
    #Master节点名
    MASTER_NODE_NAME=master1
    #节点内网实际ip
    MASTER_IP=192.168.43.203
    APISERVER_NAME=k8s.apis.1
    POD_SUBNET=10.100.0.1/20
    EOF
    source ~/env

##### 步骤三、 安装kubelet和docker
    ~/install-kubelet.sh

##### 步骤四、 初始化Master节点
    ~/init-master.sh 
    watch kubectl get pod -n kube-system -o wide
    
#### 使Master成为Node节点
    kubectl taint nodes --all node-role.kubernetes.io/master-

#### Node节点
##### 步骤一、 解压离线包
    cd ~
    tar zxvf docker-18.09.7.tar.gz
    tar zxvf nfs.tar.gz
    tar zxvf utils.tar.gz
    tar zxvf k8s-v1.16.2-pkgs-rpm.tar.gz

##### 步骤二、 设置环境变量
    cat>env<<EOF
    #节点内网实际ip
    MASTER_IP=192.168.43.203
    APISERVER_NAME=k8s.apis.1
    EOF
    source ~/env

##### 步骤三、 安装kubelet和docker
    ~/install-kubelet.sh

##### 步骤四、加载node节点需要的镜像
    docker load -i kubernetes_node.tar

##### Master节点执行获得 join命令参数
    kubeadm token create --print-join-command
 
##### 加入集群
    echo "${MASTER_IP}    ${APISERVER_NAME}" >> /etc/hosts
       
    #使用命令输出加入集群如:
    kubeadm join k8s.apis.1:6443 \
    --token bc6ufd.aepy9b6jslezum7w    \
    --discovery-token-ca-cert-hash \
    sha256:46012650b7df57b364ac1f218971b706eb4e0bd136014371569334ce2159621d 

####  移除节点

#### node节点执行
    kubeadm reset

#### Master节点执行
    kubeadm delete node node-name
