## 概览

![](/images/组件详细说明.png)

## kube-apiserver

    实现功能:
    1.为 api 对象验证并配置数据，包括 pods、 services、 replicationcontrollers和其它 api 对象
    2.提供 REST 操作和到集群共享状态的前端,所有其他组件通过它进行交互

    #启动参数
    --advertise-address=172.16.1.2
    --allow-privileged=true
    --authorization-mode=Node,RBAC
    --client-ca-file=/etc/kubernetes/pki/ca.crt
    --enable-admission-plugins=NodeRestriction
    --enable-bootstrap-token-auth=true
    --etcd-cafile=/etc/kubernetes/pki/etcd/ca.crt
    --etcd-certfile=/etc/kubernetes/pki/apiserver-etcd-client.crt
    --etcd-keyfile=/etc/kubernetes/pki/apiserver-etcd-client.key
    --etcd-servers=https://127.0.0.1:2379
    --insecure-port=0
    --kubelet-client-certificate=/etc/kubernetes/pki/apiserver-kubelet-client.crt
    --kubelet-client-key=/etc/kubernetes/pki/apiserver-kubelet-client.key
    --kubelet-preferred-address-types=InternalIP,ExternalIP,Hostname
    --proxy-client-cert-file=/etc/kubernetes/pki/front-proxy-client.crt
    --proxy-client-key-file=/etc/kubernetes/pki/front-proxy-client.key
    --requestheader-allowed-names=front-proxy-client
    --requestheader-client-ca-file=/etc/kubernetes/pki/front-proxy-ca.crt
    --requestheader-extra-headers-prefix=X-Remote-Extra-
    --requestheader-group-headers=X-Remote-Group
    --requestheader-username-headers=X-Remote-User
    --secure-port=6443
    --service-account-key-file=/etc/kubernetes/pki/sa.pub
    --service-cluster-ip-range=10.96.0.0/16
    --tls-cert-file=/etc/kubernetes/pki/apiserver.crt
    --tls-private-key-file=/etc/kubernetes/pki/apiserver.key

### 常用参数说明

![](https://github.com/osoctz/k8s-learning/blob/master/images/apiserver/parameters.png)                                                                                                                  

### 准入控制插件说明

![](https://github.com/osoctz/k8s-learning/blob/master/images/apiserver/%E6%8E%A7%E5%88%B6%E6%8F%92%E4%BB%B6.png)

## etcd
    
    #实现功能
    保存 Kubernetes 所有集群数据的后台数据库

    # 启动参数
    --advertise-client-urls=https://172.16.1.2:2379
    --cert-file=/etc/kubernetes/pki/etcd/server.crt
    --client-cert-auth=true
    --data-dir=/var/lib/etcd
    --initial-advertise-peer-urls=https://172.16.1.2:2380
    --initial-cluster=master1=https://172.16.1.2:2380
    --key-file=/etc/kubernetes/pki/etcd/server.key
    --listen-client-urls=https://127.0.0.1:2379,https://172.16.1.2:2379
    --listen-metrics-urls=http://127.0.0.1:2381
    --listen-peer-urls=https://172.16.1.2:2380
    --name=master1
    --peer-cert-file=/etc/kubernetes/pki/etcd/peer.crt
    --peer-client-cert-auth=true
    --peer-key-file=/etc/kubernetes/pki/etcd/peer.key
    --peer-trusted-ca-file=/etc/kubernetes/pki/etcd/ca.crt
    --snapshot-count=10000
    --trusted-ca-file=/etc/kubernetes/pki/etcd/ca.crt

### 常用参数说明
![](https://github.com/osoctz/k8s-learning/blob/master/images/etcd/etcd_parameters.png)

### 验证
    etcdctl --endpoints="http://172.31.32.25:2379,http://172.31.32.26:2379" cluster-health
    
## kube-scheduler
    
    #实现功能
    负责POD调度,分配到具体Node
    
    # 启动参数
    --authentication-kubeconfig=/etc/kubernetes/scheduler.conf
    --authorization-kubeconfig=/etc/kubernetes/scheduler.conf
    --bind-address=127.0.0.1
    --kubeconfig=/etc/kubernetes/scheduler.conf
    --leader-elect=true
    
### 常用参数说明
![](https://github.com/osoctz/k8s-learning/blob/master/images/scheduler/scheduler_paramers.png)

## kube-controller-manager
    #实现功能
    负责集群内的Node、Pod副本、服务端点（Endpoint）、命名空间（Namespace）、服务账号（ServiceAccount）、资源定额（ResourceQuota）的管理
    
    # 启动参数
    --allocate-node-cidrs=true
    --authentication-kubeconfig=/etc/kubernetes/controller-manager.conf
    --authorization-kubeconfig=/etc/kubernetes/controller-manager.conf
    --bind-address=127.0.0.1
    --client-ca-file=/etc/kubernetes/pki/ca.crt
    --cluster-cidr=10.100.0.1/20
    --cluster-signing-cert-file=/etc/kubernetes/pki/ca.crt
    --cluster-signing-key-file=/etc/kubernetes/pki/ca.key
    --controllers=*,bootstrapsigner,tokencleaner
    --kubeconfig=/etc/kubernetes/controller-manager.conf
    --leader-elect=true
    --node-cidr-mask-size=24
    --requestheader-client-ca-file=/etc/kubernetes/pki/front-proxy-ca.crt
    --root-ca-file=/etc/kubernetes/pki/ca.crt
    --service-account-private-key-file=/etc/kubernetes/pki/sa.key
    --service-cluster-ip-range=10.96.0.0/16
    --use-service-account-credentials=true
    
## kubelet

    #功能
    k8s在每个节点（node）上都要运行一个 worker 对容器进行生命周期的管理，这个 worker 程序就是 kubelet
    
    #启动参数
    --bootstrap-kubeconfig=/etc/kubernetes/bootstrap-kubelet.conf 
    --kubeconfig=/etc/kubernetes/kubelet.conf
    --cgroup-driver=systemd
    --network-plugin=cni
    --pod-infra-container-image=registry.cn-hangzhou.aliyuncs.com/google_containers/pause:3.1
    
### 常用参数说明


## kube-proxy

    #启动参数
    --cluster-cidr=10.100.0.1/20
    --kubeconfig=/var/lib/kube-proxy/kubeconfig.conf
    
### 常用参数说明