#!/bin/bash

source ~/env

hostnamectl set-hostname $MASTER_NODE_NAME
hostnamectl status
echo "127.0.0.1   $(hostname)" >> /etc/hosts

echo "${MASTER_IP}    ${APISERVER_NAME}" >> /etc/hosts

cat <<EOF > ./kubeadm-config.yaml
apiVersion: kubeadm.k8s.io/v1beta2
kind: ClusterConfiguration
kubernetesVersion: v1.16.2
imageRepository: registry.cn-hangzhou.aliyuncs.com/google_containers
controlPlaneEndpoint: "${APISERVER_NAME}:6443"
networking:
  serviceSubnet: "10.96.0.0/16"
  podSubnet: "${POD_SUBNET}"
  dnsDomain: "cluster.local"
EOF

docker load -i k8s-v1.16.2-images.tar
kubeadm init --config=kubeadm-config.yaml --upload-certs

rm -rf /root/.kube/
mkdir /root/.kube/
cp -i /etc/kubernetes/admin.conf /root/.kube/config

sed -i "s#192\.168\.0\.0/16#${POD_SUBNET}#" calico-3.9.2.yaml

kubectl apply -f calico-3.9.2.yaml
