## 环境说明
    [root@example ~]# cat /etc/redhat-release
    CentOS Linux release 7.7.1908 (Core)

## 服务端安装
    #只安装 nfs-utils 即可，rpcbind 属于它的依赖，也会安装上
    sudo yum install nfs-utils

## 设置 NFS 服务开机启动
    sudo systemctl enable rpcbind
    sudo systemctl enable nfs
    
    sudo systemctl start rpcbind
    sudo systemctl start nfs

## 如果开启防火墙,防火墙设置
    sudo firewall-cmd --zone=public --permanent --add-service={rpc-bind,mountd,nfs}
    sudo firewall-cmd --reload

## 配置共享目录
    sudo mkdir /data
    sudo chmod 755 /data

    # 根据这个目录，相应配置导出目录
    vi /etc/exports
    /data/     172.16.1.0/24(rw,sync,no_root_squash,no_all_squash)
    
    #配置说明
    /data: 共享目录位置。
    172.16.1.0/24: 客户端 IP 范围，* 代表所有，即没有限制。
    rw: 权限设置，可读可写。
    sync: 同步共享目录。
    no_root_squash: 可以使用 root 授权。
    no_all_squash: 可以使用普通用户授权。
    
    # 重启nfs
    systemctl restart nfs

## 验证

    [root@example ~]# showmount -e localhost
    Export list for localhost:
    /data 172.16.0.0/24
    
## 客户端安装
    sudo yum install nfs-utils

## 客户端启动
    sudo systemctl enable rpcbind
    sudo systemctl start rpcbind

## 验证

    master1:~>showmount -e 192.168.207.100
    Export list for 192.168.207.100:
    /data 172.16.1.0/24

## 挂载
    sudo mount -t nfs 192.168.207.100:/data /mongo/data
